package ca::gc::aafc::demos::furnituremodel::Table;

our $VERSION = '0.01';

our @ISA = qw(
	ca::gc::aafc::demos::furnituremodel::Furniture
	);

use ca::gc::aafc::demos::furnituremodel::Furniture;

sub new {
	my ($class,%ARG) = @_;
	$self = {};
	$args = \%ARG;
	bless($self,$class);
	return $self;
}

		# <association procedures as stated in this model>
sub addNail {
	my ($self, $newNail) = @_;
	if (!$newNail) { return; }
		# this should take in an object of the type (ca::gc::aafc::demos::furnituremodel::Nail)
	if (!UNIVERSAL::isa($newNail,ca::gc::aafc::demos::furnituremodel::Nail)) {
		die "Someone called addNail but the argument provided was not of the type (ca::gc::aafc::demos::furnituremodel::Nail)";
	}
	push @{$self->{'nails'}},$newNail;
}

sub setNails {
	my ($self, $newNails) = @_;
	if (!$newNails) { return; }
		# this should take in an object of the type (ARRAY)
	if (!UNIVERSAL::isa($newNails,ARRAY)) {
		die "Someone called setNails but the argument provided was not of the type (ARRAY)";
	}
	$self->{'nails'} = $newNail;
}

sub getNails {
	my ($self) = @_;
	return $self->{'nails'};
}

sub removeNail {
	my ($self, $nail) = @_;
	if (!$nail) { return; }
		# this should take in an object of the type (ca::gc::aafc::demos::furnituremodel::Nail)
	if (!UNIVERSAL::isa($nail,ca::gc::aafc::demos::furnituremodel::Nail)) {
		die "Someone called removeNail but the argument provided was not of the type (ca::gc::aafc::demos::furnituremodel::Nail)";
	}
	if (!$self->getNails()) {
		return;
	}
	my $new;
	foreach my $current (@{$self->getNails()}) {
		if ($current == $Nail) {
			# do nothing. this element will be removed.
		}
		else {
			push @$new,$current;
		}
	}
	$self->{'nails'} = $new;
}

sub addLeg {
	my ($self, $newLeg) = @_;
	if (!$newLeg) { return; }
		# this should take in an object of the type (ca::gc::aafc::demos::furnituremodel::Leg)
	if (!UNIVERSAL::isa($newLeg,ca::gc::aafc::demos::furnituremodel::Leg)) {
		die "Someone called addLeg but the argument provided was not of the type (ca::gc::aafc::demos::furnituremodel::Leg)";
	}
	push @{$self->{'legs'}},$newLeg;
}

sub setLegs {
	my ($self, $newLegs) = @_;
	if (!$newLegs) { return; }
		# this should take in an object of the type (ARRAY)
	if (!UNIVERSAL::isa($newLegs,ARRAY)) {
		die "Someone called setLegs but the argument provided was not of the type (ARRAY)";
	}
	$self->{'legs'} = $newLeg;
}

sub getLegs {
	my ($self) = @_;
	return $self->{'legs'};
}

sub removeLeg {
	my ($self, $leg) = @_;
	if (!$leg) { return; }
		# this should take in an object of the type (ca::gc::aafc::demos::furnituremodel::Leg)
	if (!UNIVERSAL::isa($leg,ca::gc::aafc::demos::furnituremodel::Leg)) {
		die "Someone called removeLeg but the argument provided was not of the type (ca::gc::aafc::demos::furnituremodel::Leg)";
	}
	if (!$self->getLegs()) {
		return;
	}
	my $new;
	foreach my $current (@{$self->getLegs()}) {
		if ($current == $Leg) {
			# do nothing. this element will be removed.
		}
		else {
			push @$new,$current;
		}
	}
	$self->{'legs'} = $new;
}

sub setTop {
	my ($self, $newtop) = @_;
	if (!$newtop) { return; }
		# this should take in an object of the type (ca::gc::aafc::demos::furnituremodel::Top)
	if (!UNIVERSAL::isa($newtop,ca::gc::aafc::demos::furnituremodel::Top)) {
		die "Someone called setTop but the argument provided was not of the type (ca::gc::aafc::demos::furnituremodel::Top)";
	}
	$self->{'top'} = $newtop;
}

sub getTop {
	my ($self) = @_;
	return $self->{'top'};
}

sub addTop {
	my ($self, $newTop) = @_;
	if (!$newTop) { return; }
		# this should take in an object of the type (ca::gc::aafc::demos::furnituremodel::Top)
	if (!UNIVERSAL::isa($newTop,ca::gc::aafc::demos::furnituremodel::Top)) {
		die "Someone called addTop but the argument provided was not of the type (ca::gc::aafc::demos::furnituremodel::Top)";
	}
	$self->{'top'} = $newTop;
}

		# </ association procedures as stated in this model>
		# <attribute procedures as stated in this model>
sub getHeight {
	my ($self) = @_;
	return $self->{'height'};
}

sub setHeight {
	my ($self, $newheight) = @_;
	if (!$newheight) { return; }
		# this should take in an object of the type (scalar)
	$self->{'height'} = $newheight;
}

sub getColour {
	my ($self) = @_;
	return $self->{'colour'};
}

sub setColour {
	my ($self, $newcolour) = @_;
	if (!$newcolour) { return; }
		# this should take in an object of the type (scalar)
	$self->{'colour'} = $newcolour;
}

		# </ attribute procedures as stated in this model>
		# <procedures as stated in this model>
sub operation_without_signature {
	my ($self) = @_;
 	warn("Someone called a procedure named operation_without_signature but it is not implemented. Bad coder- they failed to implement a method for a class they inherited.");
}
sub operation_returning_jlvoid {
	my ($self) = @_;
 	warn("Someone called a procedure named operation_returning_jlvoid but it is not implemented. Bad coder- they failed to implement a method for a class they inherited.");
}
sub operation_returning_leg {
	my ($self, $leg_number) = @_;
 	warn("Someone called a procedure named operation_returning_leg but it is not implemented. Bad coder- they failed to implement a method for a class they inherited.");
}
sub shorten {
	my ($self, $new_height) = @_;
 	warn("Someone called a procedure named shorten but it is not implemented. Bad coder- they failed to implement a method for a class they inherited.");
}
sub paint {
	my ($self, $new_colour) = @_;
 	warn("Someone called a procedure named paint but it is not implemented. Bad coder- they failed to implement a method for a class they inherited.");
}
sub elaborate_signature {
	my ($self, $top, $leg, $nail) = @_;
 	warn("Someone called a procedure named elaborate_signature but it is not implemented. Bad coder- they failed to implement a method for a class they inherited.");
}
sub returns_int {
	my ($self) = @_;
 	warn("Someone called a procedure named returns_int but it is not implemented. Bad coder- they failed to implement a method for a class they inherited.");
}
		# </procedures as stated in this model>


1;

